<template>
  <v-container>
    <v-row
      v-for="(installment, index) in value"
      :key="installment.id"
    >
      <align-content-center-container>
        <installment-number
          :number="index+1"
          size="large"
        />
      </align-content-center-container>
      <v-col>
        <date-picker-single-field
          v-model="installment.referenceMonth"
          :label="$t('form.referenceMonth', { requiredFlag: '*' })"
          :min="minDate"
          :max="maxDate"
          :disabled="disabled"
          type-month
          required
          @input="updateInstallments(value)"
        />
      </v-col>
      <v-col>
        <money-text-field
          v-model="installment.amount"
          :disabled="disabled"
          required
          @input="updateInstallments(value)"
        />
      </v-col>
      <v-col>
        <date-picker-single-field
          v-model="installment.dueDate"
          :label="$t('form.dueDate')"
          :disabled="disabled"
          :min="minDate"
          :max="maxDate"
          @input="updateInstallments(value)"
        />
      </v-col>
      <v-col>
        <date-picker-single-field
          v-model="installment.paidOutAt"
          :label="$t('form.paidOutAt')"
          :disabled="disabled"
          :min="minDate"
          :max="maxDate"
          @input="updateInstallments(value)"
        />
      </v-col>
      <align-content-center-container>
        <remove-icon-btn
          :disabled="isThereOnlyOneInstallment || disabled"
          @click="onClickRemove(index)"
        />
      </align-content-center-container>
    </v-row>
    <v-row>
      <v-col>
        <installments-add-cta />
      </v-col>
      <align-content-center-container>
        <add-icon-btn
          :disabled="disableAddButton || disabled"
          @click="onClickAdd"
        />
      </align-content-center-container>
    </v-row>
  </v-container>
</template>

<script>
  import { maxBy } from 'lodash'
  // components
  import InstallmentNumber from './InstallmentNumber'
  import InstallmentsAddCta from './InstallmentsAddCta'
  import AlignContentCenterContainer from './AlignContentCenterContainer'

  export default {
    name: 'InstallmentsForm',
    components: {
      InstallmentNumber,
      InstallmentsAddCta,
      AlignContentCenterContainer,
    },
    inheritAttrs: false,
    props: {
      value: {
        type: Array,
        required: true,
      },
      template: {
        type: Object,
        required: true,
      },
      disableAddButton: {
        type: Boolean,
        required: false,
        default: false,
      },
      disabled: {
        type: Boolean,
        required: false,
        default: false,
      },
      minDate: {
        type: String,
        required: true,
      },
      maxDate: {
        type: String,
        required: true,
      },
      isEdit: {
        type: Boolean,
        required: false,
        default: false,
      },
    },
    computed: {
      isThereOnlyOneInstallment () {
        return this.value.length === 1
      },
    },
    created () {
      this.$emit('reset', this.resetForm)
      this.$emit('bulkGenerateInstallments', this.bulkGenerateInstallments)
    },
    methods: {
      updateInstallments (updatedInstallments) {
        this.$emit('input', updatedInstallments)
      },
      clearInstallments () {
        this.updateInstallments([])
      },
      getNextId () {
        return maxBy(this.value, 'id').id + 1
      },
      getNewInstallment () {
        return {
          id: this.getNextId(),
          ...this.template,
          new: true,
        }
      },
      bulkGenerateInstallments (numberOfInstallments) {
        this.clearInstallments()
        const updatedInstallments = []
        for (let i = 1; i <= numberOfInstallments; i++) {
          updatedInstallments.push(this.getNewInstallment())
        }
        this.updateInstallments(updatedInstallments)
      },
      resetForm () {
        const NUMBER_OF_INSTALLMENTS = 1
        this.bulkGenerateInstallments(NUMBER_OF_INSTALLMENTS)
      },
      emitOnClickAdd () {
        this.$emit('onClickAdd')
      },
      onClickAdd () {
        const updatedInstallments = this.value
        updatedInstallments.push(this.getNewInstallment())
        this.updateInstallments(updatedInstallments)
        this.emitOnClickAdd()
      },
      removeArrayItem (array, indexToRemove) {
        const NUMBER_OF_ITEMS_TO_REMOVE = 1
        array.splice(indexToRemove, NUMBER_OF_ITEMS_TO_REMOVE)
        return array
      },
      emitOnClickRemove () {
        this.$emit('onClickRemove')
      },
      onClickRemove (indexToRemove) {
        const currentInstallments = this.value
        const updatedInstallments = this.removeArrayItem(currentInstallments, indexToRemove)
        this.updateInstallments(updatedInstallments)
        this.emitOnClickRemove()
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          form: {
            referenceMonth: 'Mês de referência{requiredFlag}',
            dueDate: 'Data de vencimento',
            paidOutAt: 'Pago em',
          },
        },
        'en-US': {
          form: {
            referenceMonth: 'Reference month{requiredFlag}',
            dueDate: 'Due date',
            paidOutAt: 'Paid out at',
          },
        },
      },
    },
  }
</script>
